clear all;
rho=0.75;
nx	= 6;
ny	= 6;
ax	= 0.01;
bx	= 2;
ay	= 0.01;
by	= 2;
dx	= (bx-ax)/(nx-1);
dy	= (by-ay)/(ny-1);
x	= [ax:dx:bx];
y	= [ay:dy:by];

A=zeros(nx,ny);
for ix=1:nx;
   for iy=1:ny;
      A(ix,iy) = (x(ix)^rho+y(iy)^rho)^(1/rho);
   end
end

nbx=20;
nby=20;
axi	= 1.1*ax;
bxi	= 0.9*bx;
ayi	= 1.1*ay;
byi	= 0.9*by;
dxi	= (bxi-axi)/(nbx-1);
dyi	= (byi-ayi)/(nby-1);
xi		= [axi:dxi:bxi];
yi		= [ayi:dyi:byi];
txi 	= 2*(xi-ax)/(bx-ax)-1;
tyi 	= 2*(yi-ay)/(by-ay)-1;
idx	= 1+floor((xi-ax)/dx);
idy	= 1+floor((yi-ay)/dy);

Yt=zeros(nbx,nby);
Yi=zeros(nbx,nby);
for ix=1:nbx;
   for iy=1:nby;
      Yt(ix,iy) = (xi(ix)^rho+yi(iy)^rho)^(1/rho);
      Yi(ix,iy)	= A(idx(ix),idy(iy))*(1-txi(ix))*(1-tyi(iy))/4+A(idx(ix),idy(iy)+1)*(1-txi(ix))*(1+tyi(iy))/4+...
         A(idx(ix)+1,idy(iy))*(1+txi(ix))*(1-tyi(iy))/4+A(idx(ix)+1,idy(iy)+1)*(1+txi(ix))*(1+tyi(iy))/4;
   end
end

surf(xi,yi,Yt-Yi);
colormap(gray);
xlabel('x','fontname','times','fontsize',14)
ylabel('y','fontname','times','fontsize',14)
set(gca,'fontname','times','fontsize',14)
pause;
print -depsc2 res_bilin.eps
close