clear all;
rho=0.75;
mx	= 20;
my	= 20;
nx	= 5;
ny	= 5;
rx	= rcheb(mx);
ry	= rcheb(my);
ax	= 0.01;
bx	= 2;
ay	= 0.01;
by	= 2;
x	= (rx+1)*(bx-ax)/2+ax;
y	= (ry+1)*(by-ay)/2+ay;

Xx=[ones(mx,1) rx];
for i=3:nx+1;
   Xx=[Xx 2*rx.*Xx(:,i-1)-Xx(:,i-2)];
end
Xy=[ones(my,1) ry];
for i=3:ny+1;
   Xy=[Xy 2*ry.*Xy(:,i-1)-Xy(:,i-2)];
end

T2x=diag(Xx'*Xx);
T2y=diag(Xy'*Xy);
Y=zeros(mx,my);
for ix=1:mx;
   for iy=1:my;
      Y(ix,iy) = (x(ix)^rho+y(iy)^rho)^(1/rho);
   end
end

a=(Xx'*Y*Xy)./(T2x*T2y');

for i=1:mx;
   for j=1:my;
      rxi=2*(x(i)-ax)/(bx-ax)-1;
      ryi=2*(y(j)-ay)/(by-ay)-1;
      Yi(i,j)=chebychev(rxi,nx)*a*chebychev(ryi,ny)';
   end
end

surf(x,y,Y-Yi);
colormap(gray);
xlabel('x','fontname','times','fontsize',14)
ylabel('y','fontname','times','fontsize',14)
set(gca,'fontname','times','fontsize',14)
pause;
print -depsc2 res_cheb3d.eps
close