clear all;
m	= 100;
%N	= [2 6];
N	= [3 7 15];
rk	= rcheb(m);
%a	= 0.01;
%b	= 2;
a	= -3;
b	= 3;
xk	= (rk+1)*(b-a)/2+a;
G	= [];
for n=N;
   X	= chebychev(rk,n);
   Y	= min(max(-1.5,(xk-0.5).^3),2);
%   Y	= xk.^0.1;
   a	= X\Y
   G	= [G X*a];
end
subplot(221);h=plot(xk,[Y G]);
set(h(1),'linewidth',3,'color','g');
set(h(2),'linewidth',1,'color','k');
set(h(3),'linewidth',1,'color','k','linestyle','--');
set(h(4),'linewidth',2,'color','k');
[h,o]=legend('True','n=3','n=7','n=15',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',14);
xlabel('x','fontname','times','fontsize',14);
title('Approximation','fontname','times','fontsize',14);

subplot(222);h=plot(xk,[repmat(Y,1,3)-G]);
set(h(1),'linewidth',1,'color','k');
set(h(2),'linewidth',1,'color','k','linestyle','--');
set(h(3),'linewidth',2,'color','k');
[h,o]=legend('n=3','n=7','n=15',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',14);
xlabel('x','fontname','times','fontsize',14);
title('Residuals','fontname','times','fontsize',14);

pause
print -depsc2 chebnsf.eps
close
