clear all;
m	= 100;
N	= [1 2];
rk	= rcheb(m);
a	= 0.5-1.5^(1/3);
b	= 0.5+2^(1/3);
xk	= (rk+1)*(b-a)/2+a;
G	= [];
for n=N;
   X	= chebychev(rk,n);
   Y	= (xk-0.5).^3;
   a	= X\Y
   G	= [G X*a];
end
subplot(221);h=plot(xk,[Y G]);
set(h(1),'linewidth',3,'color','g');
set(h(2),'linewidth',1,'color','k');
set(h(3),'linewidth',1,'color','k','linestyle','--');
%set(h(4),'linewidth',2,'color','k');
[h,o]=legend('True','n=1','n=2',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',14);
xlabel('x','fontname','times','fontsize',14);
title('Approximation','fontname','times','fontsize',14);

subplot(222);h=plot(xk,[repmat(Y,1,2)-G]);
set(h(1),'linewidth',1,'color','k');
set(h(2),'linewidth',1,'color','k','linestyle','--');
[h,o]=legend('n=1','n=2',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',14);
xlabel('x','fontname','times','fontsize',14);
title('Residuals','fontname','times','fontsize',14);

pause
%print -depsc2 chebnsf.eps
close
