clear all;
m	= 100;
N	= [2 6];
rk	= rcheb(m);
a	= 0.01;
b	= 2;
xk	= (rk+1)*(b-a)/2+a;
G	= [];
for n=N;
   X	= chebychev(rk,n);
   Y	= xk.^0.1;
   a	= X\Y
   G	= [G X*a];
end
subplot(221);h=plot(xk,[Y G]);
set(h(1),'linewidth',3,'color','g');
set(h(3),'linewidth',1,'color','k');
set(h(2),'linewidth',1,'color','k','linestyle','--');
[h,o]=legend('True','n=2','n=6',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',12);
xlabel('x','fontname','times','fontsize',12);
title('Approximation','fontname','times','fontsize',12);

subplot(222);h=plot(xk,[repmat(Y,1,2)-G]);
set(h(2),'linewidth',1,'color','k');
set(h(1),'linewidth',1,'color','k','linestyle','--');
[h,o]=legend('n=2','n=6',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',12);
xlabel('x','fontname','times','fontsize',12);
title('Residuals','fontname','times','fontsize',12);

pause
print -depsc2 chebsf.eps
close
