clear all
NBX=4:50;
k=1;
xmin=-3;
xmax=3;
f=inline('min(max(-1.5,(x-0.5).^3),2)');

xmin=0.01;
xmax=2;
f=inline('x.^0.1');

xi=[xmin:.001:xmax-.01]';
lxi=size(xi,1);
x2=xi.*xi;
XI=[ones(lxi,1) xi x2 xi.*x2];
YI=zeros(lxi,1);
L2=zeros(length(NBX),1);
Linf=zeros(length(NBX),1);


for nbx=NBX;
YI=zeros(lxi,1);
   dx=(xmax-xmin)/(nbx-1);
   x=[xmin:dx:xmax];
   y=f(x)';
   lbi=1+floor((xi-xmin)/dx);
   
   B   = zeros((nbx-2),1);                     % creates vector B
   A(1,[1 2])=[2*(dx+dx) dx];
   for i=2:nbx-3;
      A(i,[i-1 i i+1])=[dx 2*(dx+dx) dx];
      B(i)=3*(y(i+2)-y(i+1))/dx-3*(y(i+1)-y(i))/dx;
   end
   A(nbx-2,[nbx-3 nbx-2])=[dx 2*(dx+dx)];
   c   = [0;A\B];
   a   = y(1:nbx-1);
   b   = (y(2:nbx)-y(1:nbx-1))/dx-dx*([c(2:nbx-1);0]+2*c(1:nbx-1))/3;
   d   = ([c(2:nbx-1);0]-c(1:nbx-1))/(3*dx);
   S   = [a';b';c(1:nbx-1)';d'];                  % Matrix of spline coefficients
   
   for i=1:lxi;
      xx=xi(i)-(xmin+(lbi(i)-1)*dx);
      XI=[1 xx xx*xx xx*xx*xx];      
      YI(i)=XI*S(:,lbi(i));
   end
   err=f(xi)-YI;
   L2(k)=(mean(err.^2));
   Linf(k)=max(abs(err));
   k=k+1;
end
subplot(221);h=plot(NBX,L2);
set(gca,'fontname','times','fontsize',14);
xlabel('# of nodes','fontname','times','fontsize',14);
title('L^2 error','fontname','times','fontsize',14);

subplot(222);h=plot(NBX,Linf);
set(gca,'fontname','times','fontsize',14);
xlabel('# of nodes','fontname','times','fontsize',14);
title('L^\infty error','fontname','times','fontsize',14);
pause
print -depsc2 d:\texwork\econ516\approx\sperrs.eps
close