%
% Known slope
%
xmin=0.01;
xmax=2;
n=5;
dx=(xmax-xmin)/(n-1);
x=[xmin:dx:xmax];

y=sqrt(x);
z=1./(2*sqrt(x));

xstar=zeros(n-1,1);
for i=1:n-1;
   d=(y(i+1)-y(i))/(x(i+1)-x(i));
   xs=x(i)+2*(x(i+1)-x(i))*(z(i+1)-d)/(z(i+1)-z(i));
   xm=x(i+1)+2*(x(i+1)-x(i))*(z(i)-d)/(z(i+1)-z(i));
   if 0.5*(z(i)+z(i+1))==(y(i+1)-y(i))/(x(i+1)-x(i));
      xstar=x(i+1);
      a01=y(i);
      a11=z(i);
      a21=(z(i+1)-z(i))/(2*(x(i+1)-x(i)));
      a02=y(i);
      a12=z(i);
      a22=(z(i+1)-z(i))/(2*(x(i+1)-x(i)));
      coef(i,:)=[x(i) xstar x(i+1) a01 a11 a21 a02 a12 a22];
   elseif (z(i)-d)*(z(i+1)-d)>=0;
      xstar=(x(i+1)+x(i))/2;
      zb=(2*(y(i+1)-y(i))-(z(i)*(xstar-x(i))+z(i+1)*(x(i+1)-xstar)))/(x(i+1)-x(i));
      a01=y(i);
      a11=z(i);
      a21=(zb-z(i))/(2*(xstar-x(i)));
      a02=a01+a11*(xstar-x(i))+a21*(xstar-x(i))*(xstar-x(i));
      a12=zb;
      a22=(z(i+1)-zb)/(2*(x(i+1)-xstar));
      coef(i,:)=[x(i) xstar x(i+1) a01 a11 a21 a02 a12 a22];
   elseif abs(z(i+1)-d)<abs(z(i)-d);
      xstar=(x(i)+xs)/2;
      zb=(2*(y(i+1)-y(i))-(z(i)*(xstar-x(i))+z(i+1)*(x(i+1)-xstar)))/(x(i+1)-x(i));
      a01=y(i);
      a11=z(i);
      a21=(zb-z(i))/(2*(xstar-x(i)));
      a02=a01+a11*(xstar-x(i))+a21*(xstar-x(i))*(xstar-x(i));
      a12=zb;
      a22=(z(i+1)-zb)/(2*(x(i+1)-xstar));
      coef(i,:)=[x(i) xstar x(i+1) a01 a11 a21 a02 a12 a22];
   elseif abs(z(i+1)-d)>=abs(z(i)-d);
      xstar=(x(i+1)+xm)/2;
      zb=(2*(y(i+1)-y(i))-(z(i)*(xstar-x(i))+z(i+1)*(x(i+1)-xstar)))/(x(i+1)-x(i));
      a01=y(i);
      a11=z(i);
      a21=(zb-z(i))/(2*(xstar-x(i)));
      a02=a01+a11*(xstar-x(i))+a21*(xstar-x(i))*(xstar-x(i));
      a12=zb;
      a22=(z(i+1)-zb)/(2*(x(i+1)-xstar));
      coef(i,:)=[x(i) xstar x(i+1) a01 a11 a21 a02 a12 a22];
   end
end

xi=[xmin:.01:xmax-.01]';
lxi=size(xi,1);
yi=zeros(lxi,1);
lbi=1+floor((xi-xmin)/dx);
for i=1:lxi;
   cc=coef(lbi(i),:);
   xstar=cc(2);
   if (xi(i)-xstar)<0;
      yi(i)=cc(4)+cc(5)*(xi(i)-cc(1))+cc(6)*(xi(i)-cc(1))*(xi(i)-cc(1));
   else
      yi(i)=cc(7)+cc(8)*(xi(i)-cc(2))+cc(9)*(xi(i)-cc(2))*(xi(i)-cc(2));
   end
end

h=plot(xi,[sqrt(xi) yi]);
set(h(1),'color','g','linewidth',3);   
set(h(2),'color','k','linewidth',1);
pause;
close
   