clear all
NBX=[4 8 16];
k=1;
xmin=-3;
xmax=3;
f=inline('min(max(-1.5,(x-0.5).^3),2)');

%xmin=0.01;
%xmax=2;
%f=inline('x.^0.01');

xi=[xmin:.01:xmax-.01]';
lxi=size(xi,1);
x2=xi.*xi;
XI=[ones(lxi,1) xi x2 xi.*x2];
YI=zeros(lxi,3);

for nbx=NBX;
   dx=(xmax-xmin)/(nbx-1);
   x=[xmin:dx:xmax];
   y=f(x)';
   lbi=1+floor((xi-xmin)/dx);
   
   A   = spalloc((nbx-2),(nbx-2),3*nbx-8);     % creates sparse matrix A
%   A   = zeros((nbx-2),(nbx-2));     % creates sparse matrix A
   B   = zeros((nbx-2),1);                     % creates vector B
   A(1,[1 2])=[2*(dx+dx) dx];
   for i=2:nbx-3;
      A(i,[i-1 i i+1])=[dx 2*(dx+dx) dx];
      B(i)=3*(y(i+2)-y(i+1))/dx-3*(y(i+1)-y(i))/dx;
   end
   A(nbx-2,[nbx-3 nbx-2])=[dx 2*(dx+dx)];
   c   = [0;A\B];
   a   = y(1:nbx-1);
   b   = (y(2:nbx)-y(1:nbx-1))/dx-dx*([c(2:nbx-1);0]+2*c(1:nbx-1))/3;
   d   = ([c(2:nbx-1);0]-c(1:nbx-1))/(3*dx);
   S   = [a';b';c(1:nbx-1)';d'];                  % Matrix of spline coefficients
   
   for i=1:lxi;
      xx=xi(i)-(xmin+(lbi(i)-1)*dx);
      XI=[1 xx xx*xx xx*xx*xx];      
      YI(i,k)=XI*S(:,lbi(i));
   end
   k=k+1;
end
subplot(221);h=plot(xi,[f(xi) YI]);
set(h(1),'color','g','linewidth',3)
set(h(2),'linewidth',1,'color','k');
set(h(3),'linewidth',1,'color','k','linestyle','--');
set(h(4),'linewidth',2,'color','k');
[h,o]=legend('True','n=3','n=7','n=15',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',14);
xlabel('x','fontname','times','fontsize',14);
title('Approximation','fontname','times','fontsize',14);

subplot(222);h=plot(xi,[repmat(f(xi),1,3)-YI]);
set(h(1),'linewidth',1,'color','k');
set(h(2),'linewidth',1,'color','k','linestyle','--');
set(h(3),'linewidth',2,'color','k');
[h,o]=legend('n=3','n=7','n=15',0); 
set(o(1),'fontname','times','fontsize',12);
set(gca,'fontname','times','fontsize',14);
xlabel('x','fontname','times','fontsize',14);
title('Residuals','fontname','times','fontsize',14);

pause
print -depsc2 splinensf.eps
close